/*
 *  Copyright (C) 2004-2008  gulikoza
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(AFX_DXPLAY_H__0341052B_73C9_474E_841E_051A12B1920F__INCLUDED_)
#define AFX_DXPLAY_H__0341052B_73C9_474E_841E_051A12B1920F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DXplay.h : header file
//
#define NO_DSHOW_STRSAFE

#include <windows.h>
#include <dshow.h>

#pragma comment( lib, "strmiids.lib" )

#define WM_P_GRAPHNOTIFY WM_APP + 1

#ifdef _DEBUG
#define OUTPUTDEBUG(x); OutputDebugString(x);
#else
#define OUTPUTDEBUG(x);
#endif

typedef enum TIER {
	T0_REMOVESOURCE,	// 0. remove source filter
	T1_REMOVESPLIT,		// 1. remove splitter
	T2_DISCONNECT,		// 2. disconnect all filters
	T3_REMOVEALL,		// 3. remove all filters
	T4_DELETEWND,		// 4. delete window after close
};

extern TIER tier;
extern bool bAltPath;
extern bool bVMR9;
extern bool bMpeg2Dec;
extern char szPath[MAX_PATH];

/////////////////////////////////////////////////////////////////////////////
// CDXplay window

class CDXplay
{
// Construction
public:
	CDXplay();

// Attributes
public:

// Operations
public:
	BOOL LoadMediaFile(const char*);
	BOOL SetParentWindow(HWND);
	BOOL Run(void);
	BOOL Stop(void);
	BOOL Pause(void);
	BOOL OnGraphEvent(void);
	BOOL Delete(void);
	BOOL GetVolume(long*);
	BOOL SetVolume(long);
	BOOL IsRunning(void);

// Implementation
public:
	virtual ~CDXplay();

protected:

	void BuildFilterGraph(void);
	BOOL RenderMediaFile(const char*);
	IBaseFilter* FindSource(void);
	IBaseFilter* FindSplitter(IBaseFilter*);
	void ReleaseAllFilters(void);
	void ErrorReport(HRESULT);

	IGraphBuilder *pGB;
	IMediaControl *pMC;
	IVideoWindow  *pVW;
	IMediaEventEx *pME;
	IBasicAudio   *pBA;

	HANDLE hEvent;

#ifdef _DEBUG
	char debug[256];
	HANDLE	logfile;
	DWORD dwRegister;
#endif

};

#endif // !defined(AFX_DXPLAY_H__0341052B_73C9_474E_841E_051A12B1920F__INCLUDED_)
