/*
 *  Copyright (C) 2004-2008  gulikoza
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#define DLLDIR  __declspec(dllexport)   // export DLL information

#include "DXplay.h"
#include "BaseWindow.h"

#ifndef WINAPI
#define WINAPI __stdcall
#endif

// Function prototypes
MCIDEVICEID DLLDIR WINAPI mciGetDeviceIDD(LPCTSTR lpszDevice);
MCIERROR    DLLDIR WINAPI mciSendCommandD(MCIDEVICEID mciId, UINT uMsg, DWORD dwParam1, DWORD dwParam2);

BOOL  DLLDIR WINAPI mciGetErrorStringD(DWORD fdwError, LPTSTR lpszErrorText, UINT cchErrorText);

MMRESULT DLLDIR WINAPI dxMidiGetVolume(HMIDIOUT hmo, LPDWORD pdwVolume);
MMRESULT DLLDIR WINAPI dxMidiSetVolume(HMIDIOUT hmo, DWORD dwVolume);

MCIERROR DLLDIR WINAPI dxMidiSendString(LPCTSTR lpstrCommand, LPTSTR lpstrReturnString, UINT uReturnLength, HWND hwndCallback);

MMRESULT DLLDIR WINAPI dxmcKillEvent(UINT uTimerID);
DWORD DLLDIR WINAPI dxmcGetTime(void);
MMRESULT DLLDIR WINAPI joyGetDevCapsD(UINT uJoyID, LPJOYCAPSA pjc, UINT cbjc);
MMRESULT DLLDIR WINAPI joyGetPosDx(UINT uJoyID, LPJOYINFOEX pji);

typedef MMRESULT (WINAPI *pfntimeKillEvent)(UINT);
typedef DWORD (WINAPI *pfntimeGetTime)(void);
typedef MMRESULT (WINAPI *pfnjoyGetDevCapsA)(UINT, LPJOYCAPSA, UINT);
typedef MMRESULT (WINAPI *pfnjoyGetPosEx)(UINT, LPJOYINFOEX);

// WINMM Function pointers
pfntimeKillEvent p_timeKillEvent = NULL;
pfntimeGetTime p_timeGetTime = NULL;
pfnjoyGetDevCapsA p_joyGetDevCapsA = NULL;
pfnjoyGetPosEx p_joyGetPosEx = NULL;

// Global variables
CDXplay *DShowFile = NULL;
CBaseWindow  *mainWnd = NULL;

HINSTANCE hInstance = NULL;
HINSTANCE h_winmm = NULL;

BOOL cominit;		// Has COM library been initialized
HWND m_hwnd;		// Handle to our playback window
HWND m_parent;		// Handle to our parent window
